print "Hotfixing: MailHost.MailBase: Fixing the headers handling, 1.4"
print "           Lennart Regebro, 2001-11-27"

from Products.MailHost.MailHost import *
from Products.MailHost.MailHost import _encode
from string import join


def _mungeHeaders( messageText, mto=None, mfrom=None, subject=None):
    """Sets missing message headers, and deletes Bcc.
       returns fixed message, fixed mto and fixed mfrom"""
    mfile=StringIO(string.strip(messageText))
    mo=rfc822.Message(mfile)

    if not mo.getheader('Subject'):
        if subject:
            mo['Subject'] = subject
        else:
            mo['Subject'] = '[No Subject]'

    if mto:
        if type(mto) is type('s'):
            mto=map(string.strip, string.split(mto,','))
        if not mo.getheader('To'):
            mo['To'] = join(mto, ',')
    else:
        if not mo.getheader('To'):
            raise MailHostError,"Message missing SMTP Header 'To'"
        mto = map(string.strip, string.split(mo['To'],','))
        if mo.getheader('Cc'):
            mto = mto + map(string.strip, string.split(mo['Cc'],','))
        if mo.getheader('Bcc'):
            mto = mto + map(string.strip, string.split(mo['Bcc'],','))

    if mfrom and not mo.getheader('From'):
        mo['From'] = mfrom
    else:
        if mo.getheader('From') is None:
            raise MailHostError,"Message missing SMTP Header 'From'"
        mfrom = mo['From']

    if mo.getheader('Bcc'):
        mo.__delitem__('Bcc')

    mo.rewindbody()
    finalmessage = mo
    finalmessage = mo.__str__() + '\n' + mfile.read()
    mfile.close()
    return finalmessage, mto, mfrom

def sendTemplate(trueself, self, messageTemplate, 
                 statusTemplate=None, mto=None, mfrom=None,
                 encode=None, REQUEST=None):
    'render a mail template, then send it...'
    mtemplate = getattr(self, messageTemplate)
    messageText = mtemplate(self, trueself.REQUEST)
    messageText, mto, mfrom = _mungeHeaders( messageText, mto, mfrom)
    messageText=_encode(messageText, encode)

    mailserver = SMTP(trueself.smtp_host, trueself.smtp_port)
    mailserver.sendmail(headers['from'], headers['to'], messageText)

    if not statusTemplate: return "SEND OK"

    try:
        stemplate=getattr(self, statusTemplate)
        return stemplate(self, trueself.REQUEST)
    except:
        return "SEND OK"

MailBase.sendTemplate = sendTemplate

def send(self, messageText, mto=None, mfrom=None, subject=None,
         encode=None):

    messageText, mto, mfrom = _mungeHeaders( messageText, mto, mfrom, subject)
    messageText = _encode(messageText, encode)
    smtpserver = SMTP(self.smtp_host, self.smtp_port)
    send_errors = smtpserver.sendmail(mfrom, mto, messageText)
    

MailBase.scheduledSend = send
MailBase.send = send


